Loading...
Searching...
No Matches
casacore::ExtendImage< T > Class Template Reference
images package (libcasa_images) » Images_module

More...

`#include <ExtendImage.h>`

## Public Member Functions

| ExtendImage ()
| The default constructor.
| ExtendImage (const ImageInterface< T > &image, const IPosition &newShape, const CoordinateSystem &newCsys)
| Create a ExtendImage from a Image.
| ExtendImage (const ExtendImage< T > &other)
| Copy constructor (reference semantics).
virtual | ~ExtendImage ()
ExtendImage< T > & | operator= (const ExtendImage< T > &other)
| Assignment (reference semantics).
virtual ImageInterface< T > * | cloneII () const
| Make a copy of the object (reference semantics).
virtual String | imageType () const
| Get the image type (returns name of derived class).
virtual Bool | isMasked () const
| Is the ExtendImage masked?
virtual Bool | hasPixelMask () const
| Does the image object have a pixelmask?
virtual const Lattice< Bool > & | pixelMask () const
| Get access to the pixelmask in use (thus to the pixelmask of the parent).
virtual Lattice< Bool > & | pixelMask ()
virtual const LatticeRegion * | getRegionPtr () const
| Get the region used (always returns 0).
virtual Bool | isPersistent () const
| A ExtendImage is not persistent.
virtual Bool | isPaged () const
| Is the ExtendImage paged to disk?
virtual Bool | isWritable () const
| An ExtendImage is not writable.
virtual IPosition | shape () const
| Returns the shape of the ExtendImage.
virtual uInt | advisedMaxPixels () const
| This function returns the recommended maximum number of pixels to include in the cursor of an iterator.
virtual void | resize (const TiledShape &newShape)
| Function which changes the shape of the ExtendImage.
virtual String | name (Bool stripPath=False) const
| Return the name of the parent ImageInterface object.
virtual Bool | ok () const
| Check class invariants.
virtual ImageAttrHandler & | attrHandler (Bool createHandler=False)
| Get access to the attribute handler (of the parent image).
virtual Bool | doGetSlice (Array< T > &buffer, const Slicer &section)
| Do the actual getting of an array of values.
virtual void | doPutSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| Putting data is not possible.
virtual Bool | doGetMaskSlice (Array< Bool > &buffer, const Slicer &section)
| Get a section of the mask.
virtual LatticeIterInterface< T > * | makeIter (const LatticeNavigator &navigator, Bool useRef) const
| This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.
virtual IPosition | doNiceCursorShape (uInt maxPixels) const
| Get the best cursor shape.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle the (un)locking and syncing, etc.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
| Resynchronize the Lattice object with the lattice file.
virtual void | flush ()
| Flush the data (but do not unlock).
virtual void | tempClose ()
| Temporarily close the lattice.
virtual void | reopen ()
| Explicitly reopen the temporarily closed lattice.
Public Member Functions inherited from casacore::ImageInterface< T >
| ImageInterface ()
| ImageInterface (const RegionHandler &regionHandler)
| Construct for a specific region handler object.
| ImageInterface (const ImageInterface &other)
| Copy constructor (copy semantics).
virtual | ~ImageInterface ()
virtual MaskedLattice< T > * | cloneML () const
| Make a copy of the derived object (reference semantics).
virtual Bool | setUnits (const Unit &newUnits)
| Function which get and set the units associated with the image pixels (i.e.
virtual const Unit & | units () const
virtual Bool | setCoordinateInfo (const CoordinateSystem &coords)
| Functions to set or replace the coordinate information in the Image Returns False on failure, e.g.
const CoordinateSystem & | coordinates () const
virtual LELCoordinates | lelCoordinates () const
| Function to get a LELCoordinate object containing the coordinates.
LoggerHolder & | logger ()
| Get access to the LoggerHolder.
const LoggerHolder & | logger () const
LogIO & | logSink ()
| Allow messages to be logged to this ImageInterface.
const LogIO & | logSink () const
void | appendLog (const LoggerHolder &other)
| Add the messages from the other image logger to this one.
const TableRecord & | miscInfo () const
| Often we have miscellaneous information we want to attach to an image.
virtual Bool | setMiscInfo (const RecordInterface &newInfo)
const ImageInfo & | imageInfo () const
| The ImageInfo object contains some miscellaneous information about the image which unlike that stored in MiscInfo, has a standard list of things, such as the restoring beam.
ImageInfo & | rwImageInfo ()
| Get non-const access to the ImageInfo.
virtual Bool | setImageInfo (const ImageInfo &info)
ImageAttrHandler & | roAttrHandler () const
Bool | canDefineRegion () const
| Can the image handle region definition?
virtual ImageRegion | makeMask (const String &name, Bool defineAsRegion=True, Bool setAsDefaultMask=True, Bool initialize=False, Bool value=True)
| Make a mask which is suitable for the type of image.
virtual void | defineRegion (const String &name, const ImageRegion &region, RegionHandler::GroupType, Bool overwrite=False)
| Define a region/mask belonging to the image.
virtual Bool | hasRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Does the image have a region with the given name?
virtual ImageRegion * | getImageRegionPtr (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True) const
| Get a region/mask belonging to the image from the given group (which can be Any).
virtual void | renameRegion (const String &newName, const String &oldName, RegionHandler::GroupType=RegionHandler::Any, Bool overwrite=False)
| Rename a region.
virtual void | removeRegion (const String &name, RegionHandler::GroupType=RegionHandler::Any, Bool throwIfUnknown=True)
| Remove a region/mask belonging to the image from the given group (which can be Any).
virtual Vector< String > | regionNames (RegionHandler::GroupType=RegionHandler::Any) const
| Get the names of all regions/masks.
virtual void | useMask (MaskSpecifier=MaskSpecifier())
| Use the mask as specified.
virtual void | setDefaultMask (const String &regionName)
| Set the default pixelmask to the mask with the given name (which has to exist in the "masks" group).
virtual String | getDefaultMask () const
| Get the name of the default pixelmask.
ImageRegion | getRegion (const String &regionName, RegionHandler::GroupType=RegionHandler::Any) const
| Get a region belonging to the image.
String | makeUniqueRegionName (const String &rootName, uInt startNumber=1) const
| Make a unique region name from the given root name, thus make it such that the name is not already in use for a region or mask.
Bool | toRecord (String &error, RecordInterface &outRec)
| Save and restore an ImageInterface object to or from a state Record.
Bool | fromRecord (String &error, const RecordInterface &inRec)
Public Member Functions inherited from casacore::MaskedLattice< T >
| MaskedLattice ()
| Default constructor.
| MaskedLattice (const MaskedLattice< T > &)
| Copy constructor.
virtual | ~MaskedLattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual Lattice< T > * | clone () const
| Make a copy of the derived object (reference semantics).
const LatticeRegion & | region () const
| Get the region used.
Bool | getMask (COWPtr< Array< Bool > > &buffer, Bool removeDegenerateAxes=False) const
| Get the mask or a slice from the mask.
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getMaskSlice (COWPtr< Array< Bool > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | getMask (Array< Bool > &buffer, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getMaskSlice (Array< Bool > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< Bool > | getMask (Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< Bool > | getMaskSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Public Member Functions inherited from casacore::Lattice< T >
virtual | ~Lattice ()
| a virtual destructor is needed so that it will use the actual destructor in the derived class
virtual DataType | dataType () const
| Get the data type of the lattice.
T | operator() (const IPosition &where) const
| Return the value of the single element located at the argument IPosition.
virtual T | getAt (const IPosition &where) const
virtual void | putAt (const T &value, const IPosition &where)
| Put the value of a single element.
Bool | get (COWPtr< Array< T > > &buffer, Bool removeDegenerateAxes=False) const
| Functions which extract an Array of values from a Lattice.
Bool | getSlice (COWPtr< Array< T > > &buffer, const Slicer &section, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Bool | getSlice (COWPtr< Array< T > > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
Bool | get (Array< T > &buffer, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const Slicer &section, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False)
Bool | getSlice (Array< T > &buffer, const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False)
Array< T > | get (Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const Slicer &section, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, Bool removeDegenerateAxes=False) const
Array< T > | getSlice (const IPosition &start, const IPosition &shape, const IPosition &stride, Bool removeDegenerateAxes=False) const
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where, const IPosition &stride)
| A function which places an Array of values within this instance of the Lattice at the location specified by the IPosition "where", incrementing by "stride".
void | putSlice (const Array< T > &sourceBuffer, const IPosition &where)
void | put (const Array< T > &sourceBuffer)
virtual void | set (const T &value)
| Set all elements in the Lattice to the given value.
virtual void | apply (T(*function)(T))
| Replace every element, x, of the Lattice with the result of f(x).
virtual void | apply (T(*function)(const T &))
virtual void | apply (const Functional< T, T > &function)
void | operator+= (const Lattice< T > &other)
| Add, subtract, multiple, or divide by another Lattice.
void | operator-= (const Lattice< T > &other)
void | operator*= (const Lattice< T > &other)
void | operator/= (const Lattice< T > &other)
virtual void | copyData (const Lattice< T > &from)
| Copy the data from the given lattice to this one.
virtual void | copyDataTo (Lattice< T > &to) const
| Copy the data from this lattice to the given lattice.
Public Member Functions inherited from casacore::LatticeBase
virtual | ~LatticeBase ()
| A virtual destructor is needed so that it will use the actual destructor in the derived class.
virtual Bool | canReferenceArray () const
| Can the lattice data be referenced as an array section?
virtual void | save (const String &fileName) const
| Save the image in an AipsIO file with the given name.
virtual uInt | ndim () const
| Return the number of axes in this Lattice.
virtual size_t | nelements () const
| Return the total number of elements in this Lattice.
size_t | size () const
Bool | conform (const LatticeBase &other) const
| Return a value of "True" if this instance of Lattice and 'other' have the same shape, otherwise returns a value of "False".
IPosition | niceCursorShape (uInt maxPixels) const
| Returns a recommended cursor shape for iterating through all the pixels in the Lattice.
IPosition | niceCursorShape () const
virtual uInt | maximumCacheSize () const
| Maximum cache size - not necessarily all used.
virtual void | setMaximumCacheSize (uInt howManyPixels)
| Set the maximum (allowed) cache size as indicated.
virtual void | setCacheSizeInTiles (uInt howManyTiles)
| Set the actual cache size for this Array to be big enough for the indicated number of tiles.
virtual void | setCacheSizeFromPath (const IPosition &sliceShape, const IPosition &windowStart, const IPosition &windowLength, const IPosition &axisPath)
| Set the cache size as to "fit" the indicated path.
virtual void | clearCache ()
| Clears and frees up the caches, but the maximum allowed cache size is unchanged from when setCacheSize was called.
virtual void | showCacheStatistics (ostream &os) const
| Report on cache success.

## Private Attributes

std::unique_ptr< ImageInterface< T > > | itsImagePtr
std::unique_ptr< ExtendLattice< T > > | itsExtLatPtr

## Additional Inherited Members

Protected Member Functions inherited from casacore::ImageInterface< T >
ImageInterface & | operator= (const ImageInterface &other)
| Assignment (copy semantics) is only useful for derived classes.
Bool | restoreImageInfo (const RecordInterface &rec)
| Restore the image info from the record.
void | setLogMember (const LoggerHolder &logger)
| Set the image logger variable.
void | setImageInfoMember (const ImageInfo &imageInfo)
| Set the image info variable.
void | setCoordsMember (const CoordinateSystem &coords)
| Set the coordinate system variable.
void | setUnitMember (const Unit &unit)
| Set the unit variable.
void | setMiscInfoMember (const RecordInterface &rec)
| Set the miscinfo variable.
RegionHandler * | getRegionHandler ()
| Get access to the region handler.
Protected Member Functions inherited from casacore::MaskedLattice< T >
MaskedLattice< T > & | operator= (const MaskedLattice< T > &)
| Assignment can only be used by derived classes.
Protected Member Functions inherited from casacore::Lattice< T >
| Lattice ()
| Define default constructor to satisfy compiler.
virtual void | handleMath (const Lattice< T > &from, int oper)
| Handle the Math operators (+=, -=, *=, /=).
virtual void | handleMathTo (Lattice< T > &to, int oper) const
| Lattice (const Lattice< T > &)
| Copy constructor and assignment can only be used by derived classes.
Lattice< T > & | operator= (const Lattice< T > &)
void | handleMathTo (Lattice< Bool > &, int) const
Protected Member Functions inherited from casacore::LatticeBase
| LatticeBase ()
| Define default constructor to be used by derived classes.
| LatticeBase (const LatticeBase &)
| Copy constructor and assignment can only be used by derived classes.
LatticeBase & | operator= (const LatticeBase &)
void | throwBoolMath () const
| Throw an exception for arithmetic on a Bool Lattice.

## Detailed Description

template<class T>
class casacore::ExtendImage< T >

An extension of an ImageInterface object.

### Intended use:

Public interface

### Review Status

Test programs:
  tExtendImage

### Prerequisite

- ImageInterface
- ExtendLattice

### Synopsis

Class ExtendImage can be used to (virtually) extend an image along axes with length 1 and/or to add new axes. In this way such an image can be made conformant with another image. E.g. it can be used to extend the continuum channel to subtract it from each channel in an image cube.

### Example

### Motivation

Used by LEL to handle images with different dimensionalities.

Definition at line 75 of file ExtendImage.h.

## Constructor & Destructor Documentation

## ExtendImage() [1/3]

template<class T>

casacore::ExtendImage< T >::ExtendImage | ( |  | ) |

The default constructor.

Referenced by ExtendImage(), and operator=().

## ExtendImage() [2/3]

template<class T>

casacore::ExtendImage< T >::ExtendImage | ( | const ImageInterface< T > & | image,
|  | const IPosition & | newShape,
|  | const CoordinateSystem & | newCsys )

Create a ExtendImage from a Image.

The coordinate system of the given image should be a subset of the new coordinate system. The same is true for the shape.

References casacore::ImageInterface< T >::ImageInterface().

## ExtendImage() [3/3]

template<class T>

casacore::ExtendImage< T >::ExtendImage | ( | const ExtendImage< T > & | other | ) |

Copy constructor (reference semantics).

References ExtendImage().

## ~ExtendImage()

template<class T>

virtual casacore::ExtendImage< T >::~ExtendImage | ( |  | ) |

virtual

## Member Function Documentation

## advisedMaxPixels()

template<class T>

virtual uInt casacore::ExtendImage< T >::advisedMaxPixels | ( |  | ) | const

virtual

This function returns the recommended maximum number of pixels to include in the cursor of an iterator.

Reimplemented from casacore::Lattice< T >.

## attrHandler()

template<class T>

virtual ImageAttrHandler & casacore::ExtendImage< T >::attrHandler | ( | Bool | createHandler = False | ) |

virtual

Get access to the attribute handler (of the parent image).

If a handler keyword does not exist yet, it is created if createHandler is set. Otherwise the handler is empty and no groups can be created for it.

Reimplemented from casacore::ImageInterface< T >.

References casacore::False.

## cloneII()

template<class T>

virtual ImageInterface< T > * casacore::ExtendImage< T >::cloneII | ( |  | ) | const

virtual

Make a copy of the object (reference semantics).

Implements casacore::ImageInterface< T >.

References casacore::ImageInterface< T >::ImageInterface().

## doGetMaskSlice()

template<class T>

virtual Bool casacore::ExtendImage< T >::doGetMaskSlice | ( | Array< Bool > & | buffer,
|  | const Slicer & | section )

virtual

Get a section of the mask.

Reimplemented from casacore::MaskedLattice< T >.

## doGetSlice()

template<class T>

virtual Bool casacore::ExtendImage< T >::doGetSlice | ( | Array< T > & | buffer,
|  | const Slicer & | section )

virtual

Do the actual getting of an array of values.

Implements casacore::Lattice< T >.

## doNiceCursorShape()

template<class T>

virtual IPosition casacore::ExtendImage< T >::doNiceCursorShape | ( | uInt | maxPixels | ) | const

virtual

Get the best cursor shape.

Reimplemented from casacore::LatticeBase.

## doPutSlice()

template<class T>

virtual void casacore::ExtendImage< T >::doPutSlice | ( | const Array< T > & | sourceBuffer,
|  | const IPosition & | where,
|  | const IPosition & | stride )

virtual

Putting data is not possible.

Implements casacore::Lattice< T >.

## flush()

template<class T>

virtual void casacore::ExtendImage< T >::flush | ( |  | ) |

virtual

Flush the data (but do not unlock).

By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## getRegionPtr()

template<class T>

virtual const LatticeRegion * casacore::ExtendImage< T >::getRegionPtr | ( |  | ) | const

virtual

Get the region used (always returns 0).

Implements casacore::MaskedLattice< T >.

## hasLock()

template<class T>

virtual Bool casacore::ExtendImage< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LatticeBase.

## hasPixelMask()

template<class T>

virtual Bool casacore::ExtendImage< T >::hasPixelMask | ( |  | ) | const

virtual

Does the image object have a pixelmask?

It does if its parent has a pixelmask.

Reimplemented from casacore::MaskedLattice< T >.

## imageType()

template<class T>

virtual String casacore::ExtendImage< T >::imageType | ( |  | ) | const

virtual

Get the image type (returns name of derived class).

Implements casacore::ImageInterface< T >.

## isMasked()

template<class T>

virtual Bool casacore::ExtendImage< T >::isMasked | ( |  | ) | const

virtual

Is the ExtendImage masked?

It is if its parent image is masked.

Reimplemented from casacore::MaskedLattice< T >.

## isPaged()

template<class T>

virtual Bool casacore::ExtendImage< T >::isPaged | ( |  | ) | const

virtual

Is the ExtendImage paged to disk?

Reimplemented from casacore::LatticeBase.

## isPersistent()

template<class T>

virtual Bool casacore::ExtendImage< T >::isPersistent | ( |  | ) | const

virtual

A ExtendImage is not persistent.

Reimplemented from casacore::LatticeBase.

## isWritable()

template<class T>

virtual Bool casacore::ExtendImage< T >::isWritable | ( |  | ) | const

virtual

An ExtendImage is not writable.

Reimplemented from casacore::LatticeBase.

## lock()

template<class T>

virtual Bool casacore::ExtendImage< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle the (un)locking and syncing, etc.

Reimplemented from casacore::LatticeBase.

## makeIter()

template<class T>

virtual LatticeIterInterface< T > * casacore::ExtendImage< T >::makeIter | ( | const LatticeNavigator & | navigator,
|  | Bool | useRef ) const

virtual

This function is used by the LatticeIterator class to generate an iterator of the correct type for this Lattice.

Not recommended for general use.

Reimplemented from casacore::Lattice< T >.

## name()

template<class T>

virtual String casacore::ExtendImage< T >::name | ( | Bool | stripPath = False | ) | const

virtual

Return the name of the parent ImageInterface object.

Implements casacore::ImageInterface< T >.

References casacore::False.

## ok()

template<class T>

virtual Bool casacore::ExtendImage< T >::ok | ( |  | ) | const

virtual

Check class invariants.

Implements casacore::ImageInterface< T >.

## operator=()

template<class T>

ExtendImage< T > & casacore::ExtendImage< T >::operator= | ( | const ExtendImage< T > & | other | ) |

Assignment (reference semantics).

References ExtendImage().

## pixelMask() [1/2]

template<class T>

virtual Lattice< Bool > & casacore::ExtendImage< T >::pixelMask | ( |  | ) |

virtual

Reimplemented from casacore::MaskedLattice< T >.

## pixelMask() [2/2]

template<class T>

virtual const Lattice< Bool > & casacore::ExtendImage< T >::pixelMask | ( |  | ) | const

virtual

Get access to the pixelmask in use (thus to the pixelmask of the parent).

An exception is thrown if the parent does not have a pixelmask.

Reimplemented from casacore::MaskedLattice< T >.

## reopen()

template<class T>

virtual void casacore::ExtendImage< T >::reopen | ( |  | ) |

virtual

Explicitly reopen the temporarily closed lattice.

By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## resize()

template<class T>

virtual void casacore::ExtendImage< T >::resize | ( | const TiledShape & | newShape | ) |

virtual

Function which changes the shape of the ExtendImage.

Throws an exception as resizing an ExtendImage is not possible.

Implements casacore::ImageInterface< T >.

## resync()

template<class T>

virtual void casacore::ExtendImage< T >::resync | ( |  | ) |

virtual

Resynchronize the Lattice object with the lattice file.

This function is only useful if no read-locking is used, ie. if the table lock option is UserNoReadLocking or AutoNoReadLocking. In that cases the table system does not acquire a read-lock, thus does not synchronize itself automatically.
By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## shape()

template<class T>

virtual IPosition casacore::ExtendImage< T >::shape | ( |  | ) | const

virtual

Returns the shape of the ExtendImage.

Implements casacore::LatticeBase.

## tempClose()

template<class T>

virtual void casacore::ExtendImage< T >::tempClose | ( |  | ) |

virtual

Temporarily close the lattice.

It will be reopened automatically on the next access.
By default the function does not do anything at all.

Reimplemented from casacore::LatticeBase.

## unlock()

template<class T>

virtual void casacore::ExtendImage< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LatticeBase.

## Member Data Documentation

## itsExtLatPtr

template<class T>

std::unique_ptr<ExtendLattice<T> > casacore::ExtendImage< T >::itsExtLatPtr

private

Definition at line 189 of file ExtendImage.h.

## itsImagePtr

template<class T>

std::unique_ptr<ImageInterface<T> > casacore::ExtendImage< T >::itsImagePtr

private

Definition at line 188 of file ExtendImage.h.

The documentation for this class was generated from the following file:

- images/Images/ExtendImage.h